#define DEV_ENABLE "/sys/bus/pci/devices/0000:03:00.0/enable"
#define DEV_ADDRESS 0xfe8f0000

#define CTRL 0x8060

#include <stdio.h>
#include <sys/mman.h>
#include <stdlib.h>
#include <fcntl.h>

int pciEnable(int isEnable)
{
        char cen = isEnable!=0 ? '1' : '0';
        int enable = open(DEV_ENABLE,O_WRONLY); //TODO: cest DEV_ENABLE nutno nacist prohledanim PCI seznamu
	if(enable==-1) return 0; // error TODO: Doplnit poradne chybove hlaseni
        write(enable,&cen,1); close(enable);
        return 1; 
}
int main()
{       	
        int soubor= open("/dev/mem",O_RDWR | O_SYNC);
	if(soubor==-1) return 1; // error TODO: Doplnit poradne chybove hlaseni


	// TODO: konstantu DEV_ADDRESS a delku 0x10000 musite najit prohledanim seznamu PCI zarizeni
        unsigned char * base = mmap(NULL,0x10000,PROT_WRITE | PROT_READ, MAP_SHARED,
                                    soubor, DEV_ADDRESS);
	if(base==MAP_FAILED) return 2; // error TODO: Doplnit poradne chybove hlaseni       

        if(pciEnable(1))
        {
	 *(base+CTRL)=0x80;  // zapni napajeni
         sleep(1);  // cekej 1 vterinu - kratsi doba cekani-hledejte: usleep, nanosleep
         // TODO: semestralni prace
	 *(base+CTRL)=0x00;  // vypni napajeni      
        }
        pciEnable(0);

       return 0;
}

//TODO: Podprogram pro zapis/cteni bytu na emulovane PCI sbernici
//+TODO: cteni klavesnice, 
//+TODO zapis na LCD
//+TODO: program automatu na jizdenky
